Check documentation for the latest version of DHTMLX Pivot Integration with Angular Pivot Docs

Integration with Angular

You can use dhtmlxPivot in an application created with the Angular framework.

This tutorial will help you to understand the basic principle of using dhtmlxPivot in an application based on Angular.

Initializing a project

Note, that the sample provided below is not the only way to use dhtmlxPivot in an Angular-based application. It gives you initial schema of the integration and implies further extension of the app functionality depending on your requirements.

Creating a project

Let's begin with creating our project.

At first, you need to install Angular CLI:

npm install -g @angular/cli

and create a new angular-pivot-app project folder by running the following command:

ng new angular-pivot-app

Once everything is done, you can go to the app directory and run the application:

cd angular-pivot-app
ng serve --open

After that, open a new http://localhost:4200/ browser tab and you'll see the start Angular page:

Adding Pivot to the page

Now, we can add a pivot populated with data to the page of our app. It presupposes several sub-steps, described below.

Installing "from-cdn" package

At first, we need to install the "from-cdn" package to be able to load source files of dhtmlxPivot into our app directly. For that, go to your project directory and call the command below:

npm i from-cdn

For more information on from-cdn, follow the link.

Adding Pivot component

Let's create a new Pivot component to add dhtmlxPivot to our Angular app. Run the following command in your project directory:

ng g c pivot

As a result, a new angular-pivot-app/src/app/pivot directory is created:


Now, create the angular-pivot-app/src/assets/dataset.ts file with a static set of data for loading into the pivot (see the example on Github).

You also need to add type definitions for your project. Thus, you must create the angular-pivot-app/src/types.d.ts file and add the following line of code into it:

declare const dhx: any;

Then, navigate to the pivot.component.html file and add a template for the Pivot component:

angular-pivot-app/src/app/pivot/pivot.component.html

<div class="dhx-container_inner" #pivot></div>

After that, declare styles for the Pivot component in the pivot.component.css file:

angular-pivot-app/src/app/pivot/pivot.component.css

.dhx-container_inner {
    height: 100vh;
    width: 100vw;
}

Rendering Pivot on the page

It's time to render Pivot on the page

Firstly, go to pivot.component.ts and fill it with the following content:

angular-pivot-app/src/app/pivot/pivot.component.ts

import { Output, Component, ViewChild, OnDestroy, ElementRef,
            EventEmitter, ViewEncapsulation } from "@angular/core";
import fromCDN from "from-cdn";
import dataset from "../../assets/dataset";
 
const fields = {
    rows: ["form", "name"],
    columns: ["year"],
    values: [
        { id: "oil", method: "count" },
        { id: "oil", method: "sum" },
    ],
};
 
const fieldList = [
    { id: "name", label: "Name" },
    { id: "year", label: "Year" },
    { id: "continent", label: "Continent" },
    { id: "form", label: "Form" },
    { id: "gdp", label: "GDP" },
    { id: "oil", label: "Oil" },
    { id: "balance", label: "Balance" },
    { id: "when", label: "When", type: "date", format: "%d/%m/%Y" },
];
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'app-pivot',
    styleUrls: ['./pivot.component.css'],
    templateUrl: './pivot.component.html'
})
export class PivotComponent implements OnDestroy {
    @ViewChild("pivot", { read: ElementRef })
    container: ElementRef;
 
    pivot: any;
    wait: Promise<void>;
 
    @Output() ready: EventEmitter<any> = new EventEmitter();
 
    constructor() {
        this.wait = fromCDN([
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.js",
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.css"
        ]).then(() => {
            this.pivot = new dhx.Pivot(this.container.nativeElement, {
                data: dataset,
                fields,
                fieldList,
            });
        });
    }
 
    ngOnDestroy() {
        this.pivot && this.pivot.destructor();
    }
}

Then, navigate to app.component.html and update the existing code with the following:

angular-pivot-app/src/app/app.component.html

<app-pivot></app-pivot>

After that, open the app.module.ts file and check the Pivot component is added to the declarations:

angular-pivot-app/src/app/app.module.ts

import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
 
import { AppComponent } from './app.component';
import { PivotComponent } from './pivot/pivot.component';
 
@NgModule({
    declarations: [
        AppComponent,
        PivotComponent
    ],
    imports: [
        BrowserModule
    ],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }

Now everything is ready. Let's run our application. Open http://localhost:4200/ to see Pivot that we've just created.

You can view the code on GitHub, clone or download it and use it for your projects.

Pivot Customization

Let's move on and change the appearance of the created Pivot and add custom marks to some cells.

Open the pivot.component.ts file and update its code with the following:

angular-pivot-app/src/app/pivot/pivot.component.ts

import { Output, Component, ViewChild, OnDestroy, ElementRef, 
            EventEmitter, ViewEncapsulation } from "@angular/core";
import fromCDN from "from-cdn";
import dataset from "../../assets/dataset";
 
const fields = {
    rows: ["form", "year"],
    columns: [{ id: "when", group: "dateByQuarter" }],
    values: [
        { id: "oil", method: "max" },
        { id: "oil", method: "min" },
    ],
};
const mark = function (cell, columnData, row, column) {     if (column.method === "max") {         var max = Math.max.apply(null, columnData);         if (max === parseFloat(cell)) {             return "biggestMaxCell";         }     return "customMaxCell";     }     if (cell < 10 && cell !== null) {         return "mark";     }     return false; }; const fieldList = [
    { id: "name", label: "Name" },
    { id: "year", label: "Year" },
    { id: "continent", label: "Continent" },
    { id: "form", label: "Form" },
    { id: "gdp", label: "GDP" },
    { id: "oil", label: "Oil" },
    { id: "balance", label: "Balance" },
    { id: "when", label: "When", type: "date", format: "%d/%m/%Y" },
];
 
@Component({
    encapsulation: ViewEncapsulation.None,
    selector: 'app-pivot',
    styleUrls: ['./pivot.component.css'],
    templateUrl: './pivot.component.html'
})
export class PivotComponent implements OnDestroy {
    @ViewChild("pivot", { read: ElementRef })
    container: ElementRef;
 
    pivot: any;
    wait: Promise<void>;
 
    @Output() ready: EventEmitter<any> = new EventEmitter();
 
    constructor() {
        this.wait = fromCDN([
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.js", 
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.css"
        ]).then(() => {
            this.pivot = new dhx.Pivot(this.container.nativeElement, {
                data: dataset,
                fields,
                fieldList,
                mark             });
        });
    }
 
    ngOnDestroy() {
        this.pivot && this.pivot.destructor();
    }
}

As you can see from the code sample above, we've added the new mark property to the Pivot component.

Now, go to the pivot.component.css file and define styles for the .mark, .customMaxCell, .biggestMaxCell classes in it:

angular-pivot-app/src/app/pivot/pivot.component.css

.dhx-container_inner {
    height: 100vh;
    width: 100vw;
}
 
/* for custom mark */
.mark {
    background: #757575;
    color: #fff;
}
.customMaxCell {
    background: #ffd6d6;
}
.biggestMaxCell {
    background: #fa9595;
}

That's all. Open http://localhost:4200/ and you will see a nice Pivot with colored cells on the page:

What's next

Check more samples in the DHTMLX Angular-Pivot demo. Looking at the code, you will find that all samples are created in a similar way. You can also easily add your own code or our sample into an Angular-based app.

You can find samples of dhtmlxPivot here.

Back to top

Check documentation for the latest version of DHTMLX Pivot Integration with React Pivot Docs

Integration with React

You can use dhtmlxPivot in an application created with the React framework.

This tutorial will help you to understand the basic principle of using dhtmlxPivot in an application based on React.

Initializing a project

Note, that the sample provided below is not the only way to use dhtmlxPivot in a React-based application. It gives you initial schema of the integration and implies further extension of the app functionality depending on your requirements.

Creating a project

Let's create a new "react-pivot-app" project folder for our React app by using create-react-app script. For that, run the following command:

npx create-react-app react-pivot-app

Since our app is created, you can go to the app directory and run the application:

cd react-pivot-app
 
yarn start  
// or
npm start

As a result, a new http://localhost:3000/ browser tab will open and you'll see the default React app:

Adding Pivot to the page

At this step, we'll add a pivot populated with data to the page of our app. It presupposes several sub-steps, described below.

1. Install the "from-cdn" package to be able to include source CDN files of dhtmlxPivot into our app directly. For that, go to your project directory and call the command below:

npm i from-cdn

For more information on from-cdn, follow the link.

2. Then, create the react-pivot-app/src/components/Pivot folder and add the following files there:

  • Pivot.js
  • Pivot.css
  • index.js
  • data.json file with static data for loading into your Pivot (see the example on Github). It is also possible to get data from the server if necessary.

3. After that, open the Pivot.js file and insert the following code into it:

react-pivot-app/src/components/Pivot/Pivot.js

import React, { Component } from "react";
import fromCDN from "from-cdn";
import data from "./data.json";
 
class Pivot extends Component {
    constructor(props) {
        super(props);
        this.ready = fromCDN([
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.js", 
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.css"
        ]);
    }
 
    componentDidMount() {
        this.ready.then(() => {
        // eslint-disable-next-line no-undef
            this.pivot = new dhx.Pivot("pivot", {
                data,
                fields: {
                    rows: ["form", "name"],
                    columns: ["year"],
                    values: [
                        { id: "oil", method: "count" },
                        { id: "oil", method: "max" },
                    ],
                },
                fieldList: [
                    { id: "name", label: "Name" },
                    { id: "year", label: "Year" },
                    { id: "continent", label: "Continent" },
                    { id: "form", label: "Form" },
                    { id: "gdp", label: "GDP" },
                    { id: "oil", label: "Oil" },
                    { id: "balance", label: "Balance" },
                    { id: "when", label: "When", type: "date", format: "%d/%m/%Y" },
                ],
 
                layout: {
                    footer: true
                },
            });
        });
    }
 
    componentWillUnmount() {
        this.pivot && this.pivot.destructor();
    }
 
    render() {
        return (
            <div className="dhx-container_inner" id="pivot"></div>
        );
    }
}
 
export default Pivot;

4. Navigate to Pivot.css and define the following style in it:

react-pivot-app/src/components/Pivot/Pivot.css

.dhx-container_inner {
    height: 100vh;
    width: 100vw;
}

5. Open the index.js file and add the following code into it:

react-pivot-app/src/components/Pivot/index.js

import Pivot from './Pivot';
import './Pivot.css';
 
export default Pivot;

6. Finally, navigate to App.js and fill it with the following content:

react-pivot-app/src/App.js

import React, { Component } from 'react';
import Pivot from './components/Pivot';
 
class App extends Component {
    render() {
        return (
            <div>
                <Pivot />
            </div>
        );
    }
}
 
export default App;

Now everything is ready. Let's run our application. Open http://localhost:3000/ to see Pivot that we've just created.

You can view the code on GitHub, clone or download it and use it for your projects.

Pivot Customization

Let's customize look and feel of the created Pivot.

At first, create a new mark.js file in the react-pivot-app/src/components/Pivot folder:

react-pivot-app/src/components/Pivot/mark.js

const mark = function (cell, columnData, _row, column) {
    if (column.method === "max") {
        var max = Math.max.apply(null, columnData);
        if (max === parseFloat(cell)) {
            return "biggestMaxCell";
        }
        return "customMaxCell";
    }
    if (cell < 10 && cell !== null) {
        return "mark";
    }
    return false;
};
 
export default mark;

and import it into the Pivot.js file:

react-pivot-app/src/components/Pivot/Pivot.js

import React, { Component } from "react";
import fromCDN from "from-cdn";
import data from "./data.json";
import mark from "./mark";
 
class Pivot extends Component {
    constructor(props) {
        super(props);
        this.ready = fromCDN([
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.js",
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.css"
        ]);
    }
 
    componentDidMount() {
        this.ready.then(() => {
        // eslint-disable-next-line no-undef
            this.pivot = new dhx.Pivot("pivot", {
                data,
                fields: {
                    rows: ["form", "name"],
                    columns: ["year"],
                    values: [
                        { id: "oil", method: "count" },
                        { id: "oil", method: "max" },
                    ],
                },
                fieldList: [
                    { id: "name", label: "Name" },
                    { id: "year", label: "Year" },
                    { id: "continent", label: "Continent" },
                    { id: "form", label: "Form" },
                    { id: "gdp", label: "GDP" },
                    { id: "oil", label: "Oil" },
                    { id: "balance", label: "Balance" },
                    { id: "when", label: "When", type: "date", format: "%d/%m/%Y" },
                ],
                mark,                 layout: {
                    footer: true
                },
            });
        });
    }
 
    componentWillUnmount() {
        this.pivot && this.pivot.destructor();
    }
 
    render() {
        return (
            <div className="dhx-container_inner" id="pivot"></div>
        );
    }
}
 
export default Pivot;

Now, open Pivot.css and define new styles in it:

react-pivot-app/src/components/Pivot/Pivot.css

.dhx-container_inner {
    height: 100vh;
    width: 100vw;
}
 
/* for custom mark */
 
.mark {
    background: #757575;
    color: #fff;
}
 
.customMaxCell {
    background: #ffd6d6;
}
 
.biggestMaxCell {
    background: #fa9595;
}

That's all. Open http://localhost:3000/ and you will see a nice Pivot with colored cells on the page:

What's next

Check more samples in the DHTMLX React-Pivot demo. Looking at the code, you will find that all samples are created in a similar way. You can also easily add your own code or our sample into a React-based app.

You can find samples of dhtmlxPivot here.

Back to top

Check documentation for the latest version of DHTMLX Pivot Integration with Vue.js Pivot Docs

Integration with Vue.js

You can use dhtmlxPivot in an application created with the Vue.js framework.

This tutorial will help you to understand the basic principle of using dhtmlxPivot in an application based on Vue.js.

Initializing a project

Note, that the sample provided below is not the only way to use dhtmlxPivot in a Vue.js-based application. It gives you initial schema of the integration and implies further extension of the app functionality depending on your requirements.

Creating a project

Let's begin with creating our project.

At first, you need to install Vue CLI:

npm install -g @vue/cli
// or
yarn global add @vue/cli

and create a new "vue-pivot-app" project folder by running the following command:

vue create vue-pivot-app

Once everything is done, you can go to the app directory and run the application:

cd vue-pivot-app
 
npm run serve 
//or
yarn serve

After that, open a new http://localhost:8080/ browser tab and you'll see the default Vue.js page:

Adding Pivot to the page

At this step, we'll add a pivot populated with data to the page of our app. It presupposes several sub-steps, described below.

1. Install the "from-cdn" package to be able to include source files of dhtmlxPivot into our app directly. For that, go to your project directory and call the command below:

npm i from-cdn

For more information on from-cdn, follow the link.

2. Create the vue-pivot-app/src/assets/dataset.json file with static data for loading into your Pivot (see the example on Github).

3. Then, create the vue-pivot-app/src/components/Pivot.vue file with the code like this:

vue-pivot-app/src/components/Pivot.vue

<template>
    <div class="dhx_sample-container__widget" ref="pivot"></div>
</template>
 
<script>
import fromCDN from "from-cdn";
import dataset from "../assets/dataset.json";
 
export default {
    name: "Pivot",
    data: () => ({
        pivot: null,
        fields: {
            rows: ["form", "name"],
            columns: ["year"],
            values: [
                { id: "oil", method: "count" },
                { id: "oil", method: "sum" },
            ],
        },
        fieldList: [
            { id: "name", label: "Name" },
            { id: "year", label: "Year" },
            { id: "continent", label: "Continent" },
            { id: "form", label: "Form" },
            { id: "gdp", label: "GDP" },
            { id: "oil", label: "Oil" },
            { id: "balance", label: "Balance" },
            { id: "when", label: "When", type: "date", format: "%d/%m/%Y" },
        ],
        layout: {
            footer: true,
        },
    }),
    mounted() {
        fromCDN([
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.js",
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.css"
        ]).then(() => {
            // eslint-disable-next-line no-undef
            this.pivot = new dhx.Pivot(this.$refs.pivot, {
                data: dataset,
                fields: this.fields,
                fieldList: this.fieldList,
                layout: this.layout
            });
        });
    },
    beforeDestroy() {
        if (this.pivot) {
            this.pivot.destructor();
        }
    },
};
</script>
 
<style scoped>
.dhx_sample-container__widget {
    height: 100vh;
    width: 100vw;
}
</style>

4. Finally, open the App.vue file and update its code with the following:

vue-pivot-app/src/App.vue

<template>
    <div>
        <Pivot />
    </div>
</template>
 
<script>
import Pivot from './components/Pivot.vue'
 
export default {
    name: 'App',
    components: {
        Pivot
    }
}
</script>

Now everything is ready. Let's run our application. Open http://localhost:8080/ to see Pivot that we've just created.

You can view the code on GitHub, clone or download it and use it for your projects.

Pivot Customization

Let's customize look and feel of the created Pivot.

To do that, open the Pivot.vue file, add the new mark method and define styles for .mark, .customMaxCell, .biggestMaxCell classes:

<template>
    <div class="dhx_sample-container__widget" ref="pivot"></div>
</template>
 
<script>
import fromCDN from "from-cdn";
import dataset from "../assets/dataset.json";
 
export default {
    name: "Pivot",
    data: () => ({
        pivot: null,
        fields: {
            rows: ["form", "name"],
            columns: ["year"],
            values: [
                { id: "oil", method: "count" },
                { id: "oil", method: "max" },
            ],
        },
        fieldList: [
            { id: "name", label: "Name" },
            { id: "year", label: "Year" },
            { id: "continent", label: "Continent" },
            { id: "form", label: "Form" },
            { id: "gdp", label: "GDP" },
            { id: "oil", label: "Oil" },
            { id: "balance", label: "Balance" },
            { id: "when", label: "When", type: "date", format: "%d/%m/%Y" },
        ],
        layout: {
            footer: true,
        },
        mark: function (cell, columnData, row, column) {             if (column.method === "max") {                 var max = Math.max.apply(null, columnData);                 if (max === parseFloat(cell)) {                     return "biggestMaxCell";                 }                 return "customMaxCell";             }             if (cell < 10 && cell !== null) {                 return "mark";             }             return false;         }     }),
    mounted() {
        fromCDN([
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.js", 
            "https://cdn.dhtmlx.com/pivot/pro/edge/pivot.css"
        ]).then(() => {
            // eslint-disable-next-line no-undef
            this.pivot = new dhx.Pivot(this.$refs.pivot, {
                data: dataset,
                fields: this.fields,
                fieldList: this.fieldList,
                layout: this.layout,
                mark: this.mark             });
        });
    },
    beforeDestroy() {
        if (this.pivot) {
            this.pivot.destructor();
        }
    },
};
</script>
 
<style>
.dhx_sample-container__widget {
    height: 100vh;
    width: 100vw;
}
 
/* for custom mark */
.mark {     background: #757575;     color: #fff; } .customMaxCell {     background: #ffd6d6; } .biggestMaxCell {     background: #fa9595; } </style>

That's all. Open http://localhost:8080/ and you will see a nice Pivot with colored cells on the page:

What's next

Check more samples in the DHTMLX Vue.js-Pivot demo. Looking at the code, you will find that all samples are created in a similar way. You can also easily add your own code or our sample into a Vue.js-based app.

You can find samples of dhtmlxPivot here.

Back to top